 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Linear associator with Hebb and weight decay: PCA a la Oja
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 clear; clf; hold on
 steps=1000;
 y=0; w=[0.1;0.4]; a=-pi/6;
 w_traj=zeros(length(w),steps);
 rot=[cos(a) sin(a);-sin(a) cos(a)] % rotation matrix

 for i=1:steps
    x=[0.25;0.05].*randn(2,1);%anisotropic training examples
    x=rot*x; % rotation of training examples
    y=w'*x;  % feed through network
    plot(x(1),x(2),'.')
    w=w+0.1*(x*y - y^2*w); % Oja weight update
    w_traj(:,i)=w; % recording of weight history
 end

 plot(w_traj(1,:),w_traj(2,:),'r')
 plot([0 w(1)],[0 w(2)],'k','linewidth',2)
 axis([-1 1 -1 1]);
 plot([-1 1],[0 0],'k'); plot([0 0],[-1 1],'k')
